M$Parameters = {
(******************* SM Parameters *******************)
  xiG == {TeXName -> "\\xi_G"},
  xiA == {TeXName -> "\\xi_A"},
  xiW == {TeXName -> "\\xi_W"},
  xiZ == {TeXName -> "\\xi_Z"},

  etae == {TeXName -> "\\eta_e"},
  eta1 == {TeXName -> "\\eta'"},
  eta2 == {TeXName -> "\\eta"},
  eta3 == {TeXName -> "\\eta_s"},
  etat == {TeXName -> "\\eta_{\\theta}"},
  etaZ == {TeXName -> "\\eta_Z"},

  gw == {TeXName -> "g_w"},
  g1 == {TeXName -> "g_1"},
  gs == {TeXName -> "g_s"},

  me == {TeXName -> "m_e", NumValue -> 0.0005109989461},
  mm == {TeXName -> "m_m", NumValue -> 0.1056583745},
  mtt == {TeXName -> "m_{\\tau}", NumValue -> 1.77686},
  mu == {TeXName -> "m_u", NumValue -> 0.0022},
  mc == {TeXName -> "m_c", NumValue -> 1.275},
  mt == {TeXName -> "m_t", NumValue -> 173.1},
  md == {TeXName -> "m_d", NumValue -> 0.0047},
  ms == {TeXName -> "m_s", NumValue -> 0.095},
  mb == {TeXName -> "m_b", NumValue -> 4.18},
  MW == {TeXName  -> "m_W",
         Renormalization -> {MW -> MW + dMW2/(2 MW)},
         NumValue -> 80.379},
  MZ == {TeXName  -> "m_Z",
         Renormalization -> {MZ -> MZ + dMZ2/(2 MZ)},
         NumValue -> 91.1876},

  vv == {TeXName -> "v"},
  ee == {TeXName -> "e",
         Renormalization -> {ee -> ee + dee ee},
         NumValue -> 0.302822},
  sw == {TeXName -> "s_w",
         Renormalization -> {sw -> sw + dsw},
         NumValue -> 0.4808580293600181},
  cw == {TeXName -> "c_w",
         Renormalization -> {cw -> cw + dcw},
         NumValue -> 0.876798469204868},

  Ml == {Indices -> {Index[Generation], Index[Generation]},
         Renormalization -> {Ml -> Ml + dMl},
         ComplexParameter -> True},
  Muq == {Indices -> {Index[Generation], Index[Generation]},
         Renormalization -> {Muq -> Muq + dMuq},
         ComplexParameter -> True},
  Mdq == {Indices -> {Index[Generation], Index[Generation]},
         Renormalization -> {Mdq -> Mdq + dMdq},
         ComplexParameter -> True},
  CKM == {Indices -> {Index[Generation], Index[Generation]},
          TeXName -> "V",
          NumValue -> {0.97420,0.2243,0.00394,0.218,0.997,0.0422,0.0081,0.0394,1.019},
          Unitary -> True,
          Renormalization -> {CKM -> CKM + dCKM},
          ComplexParameter -> True},

(******************* Beyond SM Parameters *******************)
  v1 == {TeXName -> "v_1"},
  v2 == {TeXName -> "v_2"},
  mHP == {TeXName -> "m_{H^{\\pm}}", Renormalization -> {mHP -> mHP + dmHP2/(2 mHP)}},
  m1 == {TeXName -> "m_1", Renormalization -> {m1 -> m1 + dm12/(2 m1)}},
  m2 == {TeXName -> "m_2", Renormalization -> {m2 -> m2 + dm22/(2 m2)}},
  m3 == {TeXName -> "m_{3\\text{R}}", Renormalization -> {m3 -> m3 + dm32/(2 m3)}},

  alf0 == {TeXName -> "\\alpha_0", Renormalization -> {alf0 -> alf0 + dalf0}},
  alf1 == {TeXName -> "\\alpha_1", Renormalization -> {alf1 -> alf1 + dalf1}},
  alf2 == {TeXName -> "\\alpha_2", Renormalization -> {alf2 -> alf2 + dalf2}},
  alf3 == {TeXName -> "\\alpha_3", Renormalization -> {alf3 -> alf3 + dalf3}},
  alf4 == {TeXName -> "\\alpha_4", Renormalization -> {alf4 -> alf4 + dalf4}},
  alf5 == {TeXName -> "\\alpha_5", Renormalization -> {alf5 -> alf5 + dalf5}},

  sb == {TeXName -> "s_{\\beta}"},
  cb == {TeXName -> "c_{\\beta}"},
  sz1 == {TeXName -> "s_{\\zeta_1}"},
  cz1 == {TeXName -> "c_{\\zeta_1}"},
  sz2 == {TeXName -> "s_{\\zeta_2}"},
  cz2 == {TeXName -> "c_{\\zeta_2}"},
  sza == {TeXName -> "s_{\\zeta_a}"},
  cza == {TeXName -> "c_{\\zeta_a}"},
  beta == {TeXName -> "\\beta", Renormalization -> {beta -> beta + dbeta}},
  zeta1 == {TeXName -> "\\zeta_1", Renormalization -> {zeta1 -> zeta1 + dzeta1}},
  zeta2 == {TeXName -> "\\zeta_2", Renormalization -> {zeta2 -> zeta2 + dzeta2}},
  zetaa == {TeXName -> "\\zeta_a", Renormalization -> {zetaa -> zetaa + dzetaa}},

  R11 == {TeXName -> "R_{11}"},
  R12 == {TeXName -> "R_{12}"},
  R13 == {TeXName -> "R_{13}"},
  R21 == {TeXName -> "R_{21}"},
  R22 == {TeXName -> "R_{22}"},
  R23 == {TeXName -> "R_{23}"},
  R31 == {TeXName -> "R_{31}"},
  R32 == {TeXName -> "R_{32}"},
  R33 == {TeXName -> "R_{33}"},

  Q11 == {TeXName -> "Q_{11}", Renormalization -> {Q11 -> Q11 + dQ11}},
  Q12 == {TeXName -> "Q_{12}", Renormalization -> {Q12 -> Q12 + dQ12}},
  Q13 == {TeXName -> "Q_{13}", Renormalization -> {Q13 -> Q13 + dQ13}},
  Q14 == {TeXName -> "Q_{14}", Renormalization -> {Q14 -> Q14 + dQ14}},
  Q21 == {TeXName -> "Q_{21}", Renormalization -> {Q21 -> Q21 + dQ21}},
  Q22 == {TeXName -> "Q_{22}", Renormalization -> {Q22 -> Q22 + dQ22}},
  Q23 == {TeXName -> "Q_{23}", Renormalization -> {Q23 -> Q23 + dQ23}},
  Q24 == {TeXName -> "Q_{24}", Renormalization -> {Q24 -> Q24 + dQ24}},
  Q31 == {TeXName -> "Q_{31}", Renormalization -> {Q31 -> Q31 + dQ31}},
  Q32 == {TeXName -> "Q_{32}", Renormalization -> {Q32 -> Q32 + dQ32}},
  Q33 == {TeXName -> "Q_{33}", Renormalization -> {Q33 -> Q33 + dQ33}},
  Q34 == {TeXName -> "Q_{34}", Renormalization -> {Q34 -> Q34 + dQ34}},
  Q41 == {TeXName -> "Q_{41}", Renormalization -> {Q41 -> Q41 + dQ41}},
  Q42 == {TeXName -> "Q_{42}", Renormalization -> {Q42 -> Q42 + dQ42}},
  Q43 == {TeXName -> "Q_{43}", Renormalization -> {Q43 -> Q43 + dQ43}},
  Q44 == {TeXName -> "Q_{44}", Renormalization -> {Q44 -> Q44 + dQ44}},
  
  (* We define X^dagger (Xd), instead of X, for convenience: *)
  Xd11 == {TeXName -> "X^{\\dagger}_{11}",
           ComplexParameter -> True,
           Renormalization -> {Xd11 -> Xd11 + dXd11}},
  Xd12 == {TeXName -> "X^{\\dagger}_{12}",
           ComplexParameter -> True,
           Renormalization -> {Xd12 -> Xd12 + dXd12}},
  Xd21 == {TeXName -> "X^{\\dagger}_{21}",
           ComplexParameter -> True,
           Renormalization -> {Xd21 -> Xd21 + dXd21}},
  Xd22 == {TeXName -> "X^{\\dagger}_{22}",
           ComplexParameter -> True,
           Renormalization -> {Xd22 -> Xd22 + dXd22}},

  m11sq == {TeXName -> "m_{11}^2", Renormalization -> {m11sq -> m11sq + dm11sq}},
  m22sq == {TeXName -> "m_{22}^2", Renormalization -> {m22sq -> m22sq + dm22sq}},
  mmusq == {TeXName -> "\\mu^2", Renormalization -> {mmusq -> mmusq + dmmusq}},
  m12sqI == {TeXName -> "m_{12\\text{I}}^2", Renormalization -> {m12sqI -> m12sqI + dm12sqI}},

  L1 == {TeXName -> "\\lambda_1", Renormalization -> {L1 -> L1 + dL1}},
  L2 == {TeXName -> "\\lambda_2", Renormalization -> {L2 -> L2 + dL2}},
  L3 == {TeXName -> "\\lambda_3", Renormalization -> {L3 -> L3 + dL3}},
  L4 == {TeXName -> "\\lambda_4", Renormalization -> {L4 -> L4 + dL4}},
  L5R == {TeXName -> "\\lambda_{5\\text{R}}", Renormalization -> {L5R -> L5R + dL5R}},
  L5I == {TeXName -> "\\lambda_{5\\text{I}}", Renormalization -> {L5I -> L5I + dL5I}},

(********* SM Counterterms *********)
  dZAA == {Counterterm -> True, TeXName -> "\\delta Z_{AA}"},
  dZAZ == {Counterterm -> True, TeXName -> "\\delta Z_{AZ}"},
  dZZA == {Counterterm -> True, TeXName -> "\\delta Z_{ZA}"},
  dZZZ == {Counterterm -> True, TeXName -> "\\delta Z_{ZZ}"},
  dZW == {Counterterm -> True, TeXName -> "\\delta Z_{W}"},
  dZdqL == {Counterterm -> True,
            TeXName -> "\\delta Z^{dq,L}",
            Indices -> {Index[Generation], Index[Generation]},
            ComplexParameter -> True},
  dZdqR == {Counterterm -> True,
            TeXName -> "\\delta Z^{dq,R}",
            Indices -> {Index[Generation], Index[Generation]},
            ComplexParameter -> True},
  dZuqL == {Counterterm -> True,
            TeXName -> "\\delta Z^{uq,L}",
            Indices -> {Index[Generation], Index[Generation]},
            ComplexParameter -> True},
  dZuqR == {Counterterm -> True,
            TeXName -> "\\delta Z^{uq,R}",
            Indices -> {Index[Generation], Index[Generation]},
            ComplexParameter -> True},
  dZlL == {Counterterm -> True,
           TeXName -> "\\delta Z^{l,L}",
           Indices -> {Index[Generation], Index[Generation]},
           ComplexParameter -> True},
  dZlR == {Counterterm -> True,
           TeXName -> "\\delta Z^{l,R}",
           Indices -> {Index[Generation], Index[Generation]},
           ComplexParameter -> True},
  dZvlL == {Counterterm -> True,
            TeXName -> "\\delta Z^{vl,L}",
            Indices -> {Index[Generation], Index[Generation]},
            ComplexParameter -> True},
  dZvlR == {Counterterm -> True,
            TeXName -> "\\delta Z^{vl,R}",
            Indices -> {Index[Generation], Index[Generation]},
            ComplexParameter -> True},
    
  dMdq == {Counterterm -> True,
          Indices -> {Index[Generation], Index[Generation]},
          ComplexParameter -> True},
  dMuq == {Counterterm -> True,
          Indices -> {Index[Generation], Index[Generation]},
          ComplexParameter -> True},
  dMl == {Counterterm -> True,
          Indices -> {Index[Generation], Index[Generation]},
          ComplexParameter -> True},
  dmuq == {Counterterm -> True,
          Indices -> {Index[Generation]},
          AllowSummation -> True,
          ComplexParameter -> True},
  dmdq == {Counterterm -> True,
          Indices -> {Index[Generation]},
          AllowSummation -> True,
          ComplexParameter -> True},
  dml == {Counterterm -> True,
          Indices -> {Index[Generation]},
          AllowSummation -> True,
          ComplexParameter -> True},

  dmeL == {Counterterm -> True, TeXName -> "\\delta m_e^L"},
  dmmL == {Counterterm -> True, TeXName -> "\\delta m_m^L"},
  dmttL == {Counterterm -> True, TeXName -> "\\delta m_{\\tau}^L"},
  dmuL == {Counterterm -> True, TeXName -> "\\delta m_u^L"},
  dmcL == {Counterterm -> True, TeXName -> "\\delta m_c^L"},
  dmtL == {Counterterm -> True, TeXName -> "\\delta m_t^L"},
  dmdL == {Counterterm -> True, TeXName -> "\\delta m_d^L"},
  dmsL == {Counterterm -> True, TeXName -> "\\delta m_s^L"},
  dmbL == {Counterterm -> True, TeXName -> "\\delta m_b^L"},

  dmeR == {Counterterm -> True, TeXName -> "\\delta m_e^R"},
  dmmR == {Counterterm -> True, TeXName -> "\\delta m_m^R"},
  dmttR == {Counterterm -> True, TeXName -> "\\delta m_{\\tau}^R"},
  dmuR == {Counterterm -> True, TeXName -> "\\delta m_u^R"},
  dmcR == {Counterterm -> True, TeXName -> "\\delta m_c^R"},
  dmtR == {Counterterm -> True, TeXName -> "\\delta m_t^R"},
  dmdR == {Counterterm -> True, TeXName -> "\\delta m_d^R"},
  dmsR == {Counterterm -> True, TeXName -> "\\delta m_s^R"},
  dmbR == {Counterterm -> True, TeXName -> "\\delta m_b^R"},

  dee == {Counterterm -> True, TeXName -> "\\delta e"},

  dMW2 == {Counterterm -> True, TeXName -> "\\delta m_W^2"},
  dMZ2 == {Counterterm -> True, TeXName -> "\\delta m_Z^2"},

  dcw == {Counterterm -> True, TeXName -> "\\delta c_w"},
  dsw == {Counterterm -> True, TeXName -> "\\delta s_w"},
  dCKM == {Counterterm -> True,
           TeXName -> "\\delta V",
           Indices -> {Index[Generation], Index[Generation]},
           ComplexParameter -> True},

(********* Beyond SM Counterterms *********)
  dmHP2 == {Counterterm -> True, TeXName -> "\\delta m_{H^+}^2"},
  dm12 == {Counterterm -> True, TeXName -> "\\delta m_1^2"},
  dm22 == {Counterterm -> True, TeXName -> "\\delta m_2^2"},
  dm32 == {Counterterm -> True, TeXName -> "\\delta m_3^2"}, 

  dalf0 == {Counterterm -> True, TeXName -> "\\delta \\alpha_0"},
  dalf1 == {Counterterm -> True, TeXName -> "\\delta \\alpha_1"},
  dalf2 == {Counterterm -> True, TeXName -> "\\delta \\alpha_2"},
  dalf3 == {Counterterm -> True, TeXName -> "\\delta \\alpha_3"},
  dalf4 == {Counterterm -> True, TeXName -> "\\delta \\alpha_4"},
  dalf5 == {Counterterm -> True, TeXName -> "\\delta \\alpha_5"}, 

  dbeta == {Counterterm -> True, TeXName -> "\\delta \\beta"},
  dzeta1 == {Counterterm -> True, TeXName -> "\\delta \\zeta_1"},
  dzeta2 == {Counterterm -> True, TeXName -> "\\delta \\zeta_2"},
  dzetaa == {Counterterm -> True, TeXName -> "\\delta \\zeta_a"},

  dQ11 == {Counterterm -> True, TeXName -> "\\delta Q_{11}"},
  dQ12 == {Counterterm -> True, TeXName -> "\\delta Q_{12}"},
  dQ13 == {Counterterm -> True, TeXName -> "\\delta Q_{13}"},
  dQ14 == {Counterterm -> True, TeXName -> "\\delta Q_{14}"},
  dQ21 == {Counterterm -> True, TeXName -> "\\delta Q_{21}"},
  dQ22 == {Counterterm -> True, TeXName -> "\\delta Q_{22}"},
  dQ23 == {Counterterm -> True, TeXName -> "\\delta Q_{23}"},
  dQ24 == {Counterterm -> True, TeXName -> "\\delta Q_{24}"},
  dQ31 == {Counterterm -> True, TeXName -> "\\delta Q_{31}"},
  dQ32 == {Counterterm -> True, TeXName -> "\\delta Q_{32}"},
  dQ33 == {Counterterm -> True, TeXName -> "\\delta Q_{33}"},
  dQ34 == {Counterterm -> True, TeXName -> "\\delta Q_{34}"},
  dQ41 == {Counterterm -> True, TeXName -> "\\delta Q_{41}"},
  dQ42 == {Counterterm -> True, TeXName -> "\\delta Q_{42}"},
  dQ43 == {Counterterm -> True, TeXName -> "\\delta Q_{43}"},
  dQ44 == {Counterterm -> True, TeXName -> "\\delta Q_{44}"},

  dXd11 == {ComplexParameter -> True,
            Counterterm -> True,
            TeXName -> "\\delta X_{11}^{\\dagger}"},
  dXd12 == {ComplexParameter -> True,
            Counterterm -> True,
            TeXName -> "\\delta X_{12}^{\\dagger}"},
  dXd21 == {ComplexParameter -> True,
            Counterterm -> True,
            TeXName -> "\\delta X_{21}^{\\dagger}"},
  dXd22 == {ComplexParameter -> True,
            Counterterm -> True,
            TeXName -> "\\delta X_{22}^{\\dagger}"},

  dm11sq == {Counterterm -> True, TeXName -> "\\delta m_{11}^2"},
  dm22sq == {Counterterm -> True, TeXName -> "\\delta m_{22}^2"},
  dmmusq == {Counterterm -> True, TeXName -> "\\delta \\mu^2"},
  dm12sqI == {Counterterm -> True, TeXName -> "\\delta m_{12\\text{I}}^2"},
  
  dL1 == {Counterterm -> True, TeXName -> "\\delta \\lambda_1"},
  dL2 == {Counterterm -> True, TeXName -> "\\delta \\lambda_2"},
  dL3 == {Counterterm -> True, TeXName -> "\\delta \\lambda_3"},
  dL4 == {Counterterm -> True, TeXName -> "\\delta \\lambda_4"},
  dL5R == {Counterterm -> True, TeXName -> "\\delta \\lambda_{5\\text{R}}"},
  dL5I == {Counterterm -> True, TeXName -> "\\delta \\lambda_{5\\text{I}}"},

  dZh1h1 == {Counterterm -> True, TeXName -> "\\delta Z_{h_1h_1}"},
  dZh1h2 == {Counterterm -> True, TeXName -> "\\delta Z_{h_1h_2}"},
  dZh1h3 == {Counterterm -> True, TeXName -> "\\delta Z_{h_1h_3}"},
  dZh1G0 == {Counterterm -> True, TeXName -> "\\delta Z_{h_1G_0}"},
  dZh2h1 == {Counterterm -> True, TeXName -> "\\delta Z_{h_2h_1}"},
  dZh2h2 == {Counterterm -> True, TeXName -> "\\delta Z_{h_2h_2}"},
  dZh2h3 == {Counterterm -> True, TeXName -> "\\delta Z_{h_2h_3}"},
  dZh2G0 == {Counterterm -> True, TeXName -> "\\delta Z_{h_2G_0}"},
  dZh3h1 == {Counterterm -> True, TeXName -> "\\delta Z_{h_3h_1}"},
  dZh3h2 == {Counterterm -> True, TeXName -> "\\delta Z_{h_3h_2}"},
  dZh3h3 == {Counterterm -> True, TeXName -> "\\delta Z_{h_3h_3}"},
  dZh3G0 == {Counterterm -> True, TeXName -> "\\delta Z_{h_3G_0}"},
  dZG0h1 == {Counterterm -> True, TeXName -> "\\delta Z_{G_0h_1}"},
  dZG0h2 == {Counterterm -> True, TeXName -> "\\delta Z_{G_0h_2}"}, 
  dZG0h3 == {Counterterm -> True, TeXName -> "\\delta Z_{G_0h_3}"},
  dZG0G0 == {Counterterm -> True, TeXName -> "\\delta Z_{G_0G_0}"},

  dZHPHP == {Counterterm -> True, TeXName -> "\\delta Z_{H^+H^+}"},
  dZHPGP == {ComplexParameter -> True,
             Counterterm -> True,
             TeXName -> "\\delta Z_{H^+G^+}"},
  dZGPHP == {ComplexParameter -> True,
             Counterterm -> True,
             TeXName -> "\\delta Z_{G^+H^+}"},
  dZGPGP == {Counterterm -> True, TeXName -> "\\delta Z_{G^+G^+}"}
}