M$ClassesDescription = {
(*************** Weyl spinors ***************)
  W[1] == {
		ClassName -> uqR,
		ClassMembers -> {uR, cR, tR},
		FlavorIndex -> Generation,
		SelfConjugate -> False,
		Renormalization -> {uqR -> uqR + 1/2 dZuqR.uqR},
		Indices -> {Index[Generation], Index[Colour]},
		QuantumNumbers -> {Q -> 2/3},
		Chirality -> Right},
  W[2] == {
		ClassName -> uqL,
		ClassMembers -> {uL, cL, tL},
		FlavorIndex -> Generation,
		SelfConjugate -> False,
		Renormalization -> {uqL -> uqL + 1/2 dZuqL.uqL},
		Indices -> {Index[Generation], Index[Colour]},
		QuantumNumbers -> {Q -> 2/3},
		Chirality -> Left},
  W[3] == {
		ClassName -> dqR,
		ClassMembers -> {dR, sR, bR},
		FlavorIndex -> Generation,
		SelfConjugate -> False,
		Renormalization -> {dqR -> dqR + 1/2 dZdqR.dqR},
		Indices -> {Index[Generation], Index[Colour]},
		QuantumNumbers -> {Q -> -1/3},
		Chirality -> Right},
  W[4] == {
		ClassName -> dqL,
		ClassMembers -> {dL, sL, bL},
		FlavorIndex -> Generation,
		SelfConjugate -> False,
		Renormalization -> {dqL -> dqL + 1/2 dZdqL.dqL},
		Indices -> {Index[Generation], Index[Colour]},
		QuantumNumbers -> {Q -> -1/3},
		Chirality -> Left},
  W[5] == {
		ClassName -> lR,		
		ClassMembers -> {eR, mR, ttR},
		FlavorIndex -> Generation,
		SelfConjugate -> False,
		Renormalization -> {lR -> lR + 1/2 dZlR.lR},
		Indices -> {Index[Generation]},
		QuantumNumbers -> {Q -> -1, LeptonNumber -> 1},
		Chirality -> Right},
  W[6] == {
		ClassName -> lL,
		ClassMembers -> {eL, mL, ttL},
		FlavorIndex -> Generation,
		SelfConjugate -> False,
		Renormalization -> {lL -> lL + 1/2 dZlL.lL},
		Indices -> {Index[Generation]},
		QuantumNumbers -> {Q -> -1, LeptonNumber -> 1},
		Chirality -> Left},
  W[7] == {
		ClassName -> vlL,
		ClassMembers -> {veL,vmL,vtL},
		FlavorIndex -> Generation,
		SelfConjugate -> False,
		Renormalization -> {vlL -> vlL + 1/2 dZvlL.vlL},
		Indices -> {Index[Generation]},
		QuantumNumbers -> {LeptonNumber -> 1},
		Chirality -> Left},
(* even knowing that there are no right-handed neutrinos, I define them, for consistency *)
  W[8] == {
		ClassName -> vlR,
		ClassMembers -> {veR,vmR,vtR},
		FlavorIndex -> Generation,
		SelfConjugate -> False,
		Renormalization -> {vlR -> vlR + 1/2 dZvlR.vlR},
		Indices -> {Index[Generation]},
		QuantumNumbers -> {LeptonNumber -> 1},
		Chirality -> Right},

(*************** Fermions ***************)
  F[1] == {
		ClassName -> vl,
		ClassMembers -> {ve,vm,vt},
		TeXName -> {"\\nu_e","\\nu_m","\\nu_{\\tau}"},
		TeXAntiName -> {"\\bar{\\nu_e}","\\bar{\\nu_m}","\\bar{\\nu_{\\tau}}"},
		FlavorIndex -> Generation,
		SelfConjugate -> False,
		Indices -> {Index[Generation]},
		Mass -> {0,0,0},
		QuantumNumbers -> {LeptonNumber -> 1},
		WeylComponents -> {vlL,vlR}},
  F[2] == {
		ClassName -> l,
		ClassMembers -> {e, m, tt},
		TeXName -> {"e","\\mu","\\tau"},
		TeXAntiName -> {"\\bar{e}","\\bar{\\mu}","\\bar{\\tau}"},
		FlavorIndex -> Generation,
		SelfConjugate -> False,
		Indices -> {Index[Generation]},
		Mass -> {me,mm,mtt},
		QuantumNumbers -> {Q -> -1, LeptonNumber -> 1},
		WeylComponents -> {lL,lR}},
  F[3] == {
		ClassName -> uq,
		ClassMembers -> {u, c, t},
		TeXName -> {"u","c","t"},
		TeXAntiName -> {"\\bar{u}","\\bar{c}","\\bar{t}"},
		FlavorIndex -> Generation,
		SelfConjugate -> False,
		Indices -> {Index[Generation], Index[Colour]},
		Mass -> {mu,mc,mt},
		QuantumNumbers -> {Q -> 2/3},
		WeylComponents -> {uqL,uqR}},
  F[4] == {
		ClassName -> dq,		
		ClassMembers -> {d, s, b},
		TeXName -> {"d","s","b"},
		TeXAntiName -> {"\\bar{d}","\\bar{s}","\\bar{b}"},	
		FlavorIndex -> Generation,
		SelfConjugate -> False,
		Indices -> {Index[Generation], Index[Colour]},
		Mass -> {md,ms,mb},
		QuantumNumbers -> {Q -> -1/3},
		WeylComponents -> {dqL,dqR}},

(*************** Ghosts ***************)
  U[1] == {
		ClassName -> ghA,
		TeXName -> "c_{\\gamma}",
		TeXAntiName -> "\\bar{c_{\\gamma}}",		
		SelfConjugate -> False,
		Ghost -> A,
		Mass -> 0,
		QuantumNumbers -> {GhostNumber -> 1}},
  U[2] == {
		ClassName -> ghZ,
		TeXName -> "c_Z",
		TeXAntiName -> "\\bar{c_Z}",
		SelfConjugate -> False,
		Mass -> MZ,
		Ghost -> Z,
		QuantumNumbers -> {GhostNumber -> 1}},
  U[31] == {
		ClassName -> ghWp,
		TeXName -> "c_{W^+}",
		TeXAntiName -> "\\bar{c_{W^+}}",
		SelfConjugate -> False,
		Mass -> MW,
		Ghost -> WP,
		QuantumNumbers -> {Q-> 1, GhostNumber -> 1}},
  U[32] == {
		ClassName -> ghWm,
		TeXName -> "c_{W^-}",
		TeXAntiName -> "\\bar{c_{W^-}}",
		SelfConjugate -> False,
		Mass -> MW,
		Ghost -> WPbar,
		QuantumNumbers -> {Q-> -1, GhostNumber -> 1}},
  U[4] == {
		ClassName -> ghG,
		TeXName -> "c_g",
		TeXAntiName -> "\\bar{c_g}",
		SelfConjugate -> False,
		Indices -> {Index[Gluon]},
		Ghost -> G,
		Mass -> 0,
		QuantumNumbers -> {GhostNumber -> 1}},
  U[5] == {
		ClassName -> ghWi,
		Unphysical -> True,
		Definitions -> {ghWi[1] -> (ghWp + ghWm)/Sqrt[2],
		                ghWi[2] -> (ghWm - ghWp)/Sqrt[2]/I,
		                ghWi[3] -> cw etaZ ghZ + etat sw ghA},
		SelfConjugate -> False,
		Ghost -> Wi,
		Indices -> {Index[SU2W]},
		FlavorIndex -> SU2W},
  U[6] == {
		ClassName -> ghB,
		SelfConjugate -> False,
		Definitions -> {ghB -> - etat etaZ sw ghZ + cw ghA},
		Indices -> {},
		Ghost -> B,
		Unphysical -> True},

(*************** Gauge Bosons ***************)
	(* Gauge bosons: Q = 0 *)
  V[1] == {
		ClassName -> A,
		SelfConjugate -> True,
		TeXName -> "\\gamma",
		Renormalization -> {A[nu_] -> A[nu] + 1/2 dZAA A[nu] + 1/2 dZAZ Z[nu]},
		Mass -> 0},
  V[2] == {
		ClassName -> Z,
		SelfConjugate -> True,
		TeXName -> "Z",
		Renormalization -> {Z[nu_] -> Z[nu] + 1/2 dZZA A[nu] + 1/2 dZZZ Z[nu]},
		Mass -> MZ},
  V[3] == {
		ClassName -> WP,
		TeXName -> "W^+",
		TeXAntiName -> "W^-",
		Renormalization -> {WP[nu_] -> WP[nu] + 1/2 dZW WP[nu]},
		SelfConjugate -> False,
		Mass -> MW,
		QuantumNumbers -> {Q -> 1}},
  V[4] == {
		ClassName -> G,
		SelfConjugate -> True,
		TeXName -> "g",
		Indices -> {Index[Gluon]},
		Mass -> 0},
  V[5] == {
		ClassName -> Wi,
		SelfConjugate -> True,
		Unphysical -> True,
		Definitions -> {	Wi[mu_, 1] -> (WP[mu] + WPbar[mu])/Sqrt[2],
		                	Wi[mu_, 2] -> (WPbar[mu] - WP[mu])/Sqrt[2]/I,
		                	Wi[mu_, 3] -> etaZ cw Z[mu] + etat sw A[mu]},
		Indices -> {Index[SU2W]},
		FlavorIndex -> SU2W},
  V[6] == {
		ClassName -> B,
		SelfConjugate -> True,
		Definitions -> {B[mu_] -> - etat etaZ sw Z[mu] + cw A[mu]},
		Unphysical -> True},

(*************** Scalars ***************)
(****** Upper and lower doublet components in the symmetry basis ******)
  S[100] == {
		ClassName -> Phi1P,
		SelfConjugate  -> False,
		QuantumNumbers -> {Q -> 1},
		Definitions    -> {Phi1P -> phi1P},
		Unphysical     -> True},
  S[101] == {
		ClassName -> Phi10,
		SelfConjugate -> False,
		Definitions -> {Phi10->(cb (cz1 + I sz1) vv + r1 + I e1)/Sqrt[2]},
		Unphysical -> True},
  S[200] == {
		ClassName -> Phi2P,
		SelfConjugate -> False,
		QuantumNumbers -> {Q -> 1},
		Definitions -> {Phi2P -> phi2P},
		Unphysical -> True},
  S[201] == {
		ClassName -> Phi20,
		SelfConjugate -> False,
		Definitions -> {Phi20->(sb (cz2 + I sz2) vv + r2 + I e2)/Sqrt[2]},
		Unphysical -> True},
(****** Auxiliary fields ******)		
  S[301] == {
		ClassName -> phi1P,
		SelfConjugate -> False,
		QuantumNumbers -> {Q -> 1},
		Definitions -> {phi1P -> Xd11 GP + Xd12 HP},
		Unphysical -> True},
  S[302] == {
		ClassName -> phi2P,
		SelfConjugate -> False,
		QuantumNumbers -> {Q -> 1},
		Definitions -> {phi2P -> Xd21 GP + Xd22 HP}, 
		Unphysical -> True},
  S[303] == {
		ClassName     -> r1,
		SelfConjugate -> True,
		Definitions   -> {r1 -> h1 Q11 + h2 Q21 + h3 Q31 + G0 Q41},
		Unphysical    -> True},
  S[304] == {
		ClassName     -> r2,
		SelfConjugate -> True,
		Definitions   -> {r2 -> h1 Q12 + h2 Q22 + h3 Q32 + G0 Q42},
		Unphysical    -> True},
  S[305] == {
		ClassName     -> e1,
		SelfConjugate -> True,
		Definitions   -> {e1 -> h1 Q13 + h2 Q23 + h3 Q33 + G0 Q43},
		Unphysical    -> True},
  S[306] == {
		ClassName     -> e2,
		SelfConjugate -> True,
		Definitions   -> {e2 -> h1 Q14 + h2 Q24 + h3 Q34 + G0 Q44},
		Unphysical    -> True},
(****** Fields in the mass basis ******)	
  S[1] == {
		ClassName -> HP,
		TeXName -> "H^+",
		TeXAntiName -> "H^-",
		Renormalization -> {HP -> HP + 1/2 dZHPHP HP + 1/2 dZHPGP GP},
		SelfConjugate  -> False,
		QuantumNumbers -> {Q -> 1},
		Mass -> mHP},
  S[2] == {
		ClassName -> GP,
		TeXName -> "G^+",
		TeXAntiName -> "G^-",
		Renormalization -> {GP -> GP + 1/2 dZGPHP HP + 1/2 dZGPGP GP},		
		SelfConjugate -> False,
		QuantumNumbers -> {Q -> 1},
		Mass -> MW},
  S[3] == {
		ClassName -> h1,
		SelfConjugate -> True,
		TeXName -> "h_1",
		Renormalization -> {h1 -> h1 + 1/2 dZh1h1 h1 + 1/2 dZh1h2 h2 + 1/2 dZh1h3 h3 + 1/2 dZh1G0 G0},
		Mass -> m1},
  S[4] == {
		ClassName -> h2,
		SelfConjugate -> True,
		TeXName -> "h_2",
		Renormalization -> {h2 -> h2 + 1/2 dZh2h1 h1 + 1/2 dZh2h2 h2 + 1/2 dZh2h3 h3 + 1/2 dZh2G0 G0},		
		Mass -> m2},
  S[5] == {
		ClassName -> h3,
		SelfConjugate -> True,
		TeXName -> "h_3",
		Renormalization -> {h3 -> h3 + 1/2 dZh3h1 h1 + 1/2 dZh3h2 h2 + 1/2 dZh3h3 h3 + 1/2 dZh3G0 G0},
		Mass -> m3},
  S[6] == {
		ClassName -> G0,
		SelfConjugate -> True,
		TeXName -> "G_0",
		Renormalization -> {G0 -> G0 + 1/2 dZG0h1 h1 + 1/2 dZG0h2 h2 + 1/2 dZG0h3 h3 + 1/2 dZG0G0 G0},
		Mass -> MZ}
};
